UnderHood_Bars = UnderHood:NewModule( "Bars", UnderHood.MultiFrameModulePrototype, "AceConsole-3.0", "AceEvent-3.0" )

UnderHood_Bars.configTableName = "bars"
UnderHood_Bars.configEntryPrefix = "bar"
UnderHood_Bars.configTemplate = {
	bars = {
		["Threat"] = {
			["strata"] = "LOW",
			["animate"] = true,
			["styleSettings"] = {
				["bgColor"] = {
					0.3, -- [1]
					0.3, -- [2]
					0.3, -- [3]
					0.75, -- [4]
				},
				["showBackground"] = true,
			},
			["scale"] = 1,
			["unit"] = "player",
			["y"] = 0,
			["x"] = -236,
			["name"] = "Threat",
			["style"] = "VerticalLarge",
			["height"] = 256,
			["level"] = 6,
			["provider"] = "Threat",
			["width"] = 30,
		},
		["PetMana"] = {
			["strata"] = "LOW",
			["styleSettings"] = {
				["bgColor"] = {
					0.3, -- [1]
					0.3, -- [2]
					0.3, -- [3]
					0.75, -- [4]
				},
				["showBackground"] = true,
			},
			["scale"] = 0.51,
			["width"] = 37,
			["unit"] = "pet",
			["y"] = -123,
			["x"] = -342,
			["name"] = "PetMana",
			["style"] = "VerticalLarge",
			["provider"] = "Power",
			["level"] = 6,
			["height"] = 256,
		},
		["PetHealth"] = {
			["strata"] = "LOW",
			["styleSettings"] = {
				["bgColor"] = {
					0.3, -- [1]
					0.3, -- [2]
					0.3, -- [3]
					0.75, -- [4]
				},
				["showBackground"] = true,
			},
			["scale"] = 0.51,
			["unit"] = "pet",
			["y"] = -123,
			["x"] = -362,
			["name"] = "PetHealth",
			["style"] = "VerticalLarge",
			["provider"] = "Health",
			["level"] = 6,
			["height"] = 256,
			["width"] = 37,
		},
		["FocusHealth"] = {
			["strata"] = "LOW",
			["animate"] = true,
			["styleSettings"] = {
				["bgColor"] = {
					0.3, -- [1]
					0.3, -- [2]
					0.3, -- [3]
					0.75, -- [4]
				},
				["showBackground"] = true,
			},
			["scale"] = 0.51,
			["width"] = 37,
			["unit"] = "focus",
			["y"] = -123,
			["x"] = 456,
			["name"] = "FocusHealth",
			["style"] = "VerticalLarge",
			["provider"] = "Health",
			["level"] = 6,
			["height"] = 256,
			["providerSettings"] = {
				["colorByHostility"] = false,
				["colorByClass"] = false,
			},
			["castingBar"] = true,
		},
		["ToTHealth"] = {
			["strata"] = "LOW",
			["animate"] = true,
			["styleSettings"] = {
				["bgColor"] = {
					0.3, -- [1]
					0.3, -- [2]
					0.3, -- [3]
					0.75, -- [4]
				},
				["showBackground"] = true,
				["texture"] = "Armory",
			},
			["scale"] = 1,
			["name"] = "ToTHealth",
			["unit"] = "targettarget",
			["y"] = -126,
			["x"] = 0,
			["style"] = "Horizontal",
			["width"] = 200,
			["provider"] = "Health",
			["level"] = 6,
			["height"] = 20,
			["providerSettings"] = {
				["colorByHostility"] = true,
				["colorByClass"] = false,
			},
		},
		["FocusMana"] = {
			["strata"] = "LOW",
			["styleSettings"] = {
				["bgColor"] = {
					0.3, -- [1]
					0.3, -- [2]
					0.3, -- [3]
					0.75, -- [4]
				},
				["showBackground"] = true,
			},
			["scale"] = 0.51,
			["unit"] = "focus",
			["y"] = -123,
			["x"] = 478,
			["name"] = "FocusMana",
			["style"] = "VerticalLarge",
			["height"] = 256,
			["level"] = 6,
			["provider"] = "Power",
			["width"] = 37,
			["castingBar"] = true,
			["animate"] = true,
		},
		["PlayerHealth"] = {
			["strata"] = "LOW",
			["animate"] = true,
			["styleSettings"] = {
				["bgColor"] = {
					0.3, -- [1]
					0.3, -- [2]
					0.3, -- [3]
					0.75, -- [4]
				},
				["showBackground"] = true,
			},
			["scale"] = 1,
			["castingBar"] = true,
			["unit"] = "player",
			["y"] = 0,
			["x"] = -200,
			["name"] = "PlayerHealth",
			["width"] = 30,
			["height"] = 256,
			["level"] = 6,
			["provider"] = "Health",
			["style"] = "VerticalLarge",
		},
		["TargetHealth"] = {
			["strata"] = "LOW",
			["animate"] = true,
			["styleSettings"] = {
				["bgColor"] = {
					0.3, -- [1]
					0.3, -- [2]
					0.3, -- [3]
					0.75, -- [4]
				},
				["showBackground"] = true,
			},
			["scale"] = 1,
			["castingBar"] = true,
			["style"] = "VerticalLarge",
			["width"] = 30,
			["y"] = 0,
			["x"] = -218,
			["name"] = "TargetHealth",
			["height"] = 256,
			["provider"] = "Health",
			["level"] = 6,
			["unit"] = "target",
			["providerSettings"] = {
				["colorByHostility"] = true,
				["colorByClass"] = false,
			},
		},
		["TargetMana"] = {
			["strata"] = "LOW",
			["animate"] = true,
			["styleSettings"] = {
				["bgColor"] = {
					0.3, -- [1]
					0.3, -- [2]
					0.3, -- [3]
					0.75, -- [4]
				},
				["showBackground"] = true,
			},
			["scale"] = 1,
			["unit"] = "target",
			["y"] = 0,
			["x"] = 218,
			["name"] = "TargetMana",
			["width"] = 30,
			["height"] = 256,
			["level"] = 6,
			["provider"] = "Power",
			["style"] = "VerticalLarge",
		},
		["DruidMana"] = {
			["strata"] = "LOW",
			["animate"] = true,
			["styleSettings"] = {
				["bgColor"] = {
					0.3, -- [1]
					0.3, -- [2]
					0.3, -- [3]
					0.75, -- [4]
				},
				["showBackground"] = true,
			},
			["scale"] = 0.51,
			["width"] = 37,
			["unit"] = "player",
			["y"] = -123,
			["x"] = 364,
			["name"] = "DruidMana",
			["style"] = "VerticalLarge",
			["provider"] = "Druid Mana",
			["level"] = 6,
			["height"] = 256,
		},
		["PlayerMana"] = {
			["strata"] = "LOW",
			["animate"] = true,
			["styleSettings"] = {
				["bgColor"] = {
					0.3, -- [1]
					0.3, -- [2]
					0.3, -- [3]
					0.75, -- [4]
				},
				["showBackground"] = true,
			},
			["scale"] = 1,
			["unit"] = "player",
			["y"] = 0,
			["x"] = 200,
			["name"] = "PlayerMana",
			["width"] = 30,
			["height"] = 256,
			["level"] = 6,
			["provider"] = "Power",
			["style"] = "VerticalLarge",
		},
	},
}

function UnderHood_Bars:OnInitializeFrameConfiguration( config )
	config.provider = "Health"
	config.unit = "player"

	config.width = 32
	config.height = 256

	for styleName, style in pairs( self:GetStyles() ) do
		config.style = styleName

		if type( style.DefaultSettings ) == "function" then
			style:DefaultSettings( config )
		end

		break
	end
end

--[[--------
-- Providers
--]]

local providersRegistry = {}
local providersNameList = {}
local providersNameTable = {}

function UnderHood_Bars:RegisterProvider( provider )
	providersRegistry[provider.name] = provider
	
	table.insert( providersNameList, provider.name )
	providersNameTable[provider.name] = provider.name
end

function UnderHood_Bars:GetProviders()
	return providersRegistry
end

function UnderHood_Bars:GetProvidersNameList()
	return providersNameList
end

function UnderHood_Bars:GetProvidersNameTable()
	return providersNameTable
end

function UnderHood_Bars:GetProvider( name )
	return providersRegistry[name]
end

--[[--------
-- Providers
--]]

local stylesRegistry = {}
local stylesNameList = {}
local stylesNameTable = {}

function UnderHood_Bars:RegisterStyle( style )
	stylesRegistry[style.name] = style
	
	table.insert( stylesNameList, style.name )
	stylesNameTable[style.name] = style.title
end

function UnderHood_Bars:GetStyles()
	return stylesRegistry
end

function UnderHood_Bars:GetStylesNameList()
	return stylesNameList
end

function UnderHood_Bars:GetStylesNameTable()
	return stylesNameTable
end

function UnderHood_Bars:GetStyle( name )
	return stylesRegistry[name]
end

